/////////////////////////////////////
//Fonctions utilises en cours de niveau
/////////////////////////////////////
function TesterFinNiveau(e:Event):void
{
	if(Mode2Joueurs)
		Verifier_2Joueurs();
	else
	{
		if(GrandPere.Ferme)
			TerminerNiveau(1);
		else
		{
			if(Fond.NbJetonsToleres-Fond.NbJetonsUtilises<0)
			{
				TerminerNiveau(0);
				ChangeLevelInfo.htmlText="<b>Trop de noeuds allums !</b>";
			}
		}
	}
}

/////////////////////////////////////
//Fonctions utilises lors des changements de niveaux
/////////////////////////////////////
function AddLevel(e:Event):void
{//trigger quand on clique sur le bouton pour passer au niveau suivant.
	NumeroNiveauActuel=Math.min(NumeroNiveauUnlockes,NumeroNiveauActuel+1);
	LancerNouveauNiveau();
}
function RemoveLevel(e:Event):void
{//trigger quand on clique sur le bouton pour passer au niveau prcdent.
	NumeroNiveauActuel=Math.max(0,NumeroNiveauActuel-1);
	LancerNouveauNiveau();
}
function RetryLevel(e:Event):void
{//trigger quand on clique sur le bouton pour recommencer le niveau.
	LancerNouveauNiveau();
}

function TerminerNiveau(Valeur:int):void
{//Termine un niveau en affichant la boite de changement
//Ajoute la valeur aux niveaux unlocks.
	removeEventListener(Event.ENTER_FRAME,TesterFinNiveau);
	Fond.FlouFinal=Fond.FLOU_FINAL;
	Fond.Flou=0;
	addEventListener(Event.ENTER_FRAME,FlouFinNiveau);
	NumeroNiveauActuel+=Valeur;
	if(NumeroNiveauActuel>NumeroNiveauUnlockes && Fond.Officiel==true)
	{
		NumeroNiveauUnlockes+=Valeur;
		SESSION.NumeroNiveauActuel=NumeroNiveauActuel;
		SESSION.NumeroNiveauUnlockes=NumeroNiveauUnlockes;
		ChangeLevelInfo.htmlText="Nouveau Niveau dbloqu !";
// 		EnregistrerProgression();
	}

	UpdaterBoite();
}
function StopLevel(e:Event=null):void
{//Arrte le niveau directement.
 	TerminerNiveau(0);
  	Message_Container.visible=false;
	ChangeLevelInfo.htmlText="<b>Niveau abandonn !</b>";
}

function LancerNouveauNiveau(NumNiveau:int=-1):void
{//Lancer un niveau "quelconque"
	if(NumNiveau==-1)
		NumNiveau=NumeroNiveauActuel;

	if(Fond!=null && contains(Fond))
	{//Si Fond a dj t utilis, nettoyer l'ensemble
		Fond.Nettoyer();
		removeChild(Fond);
	}


	//SwapBackGround();
	Fond = GetLevelData(NumNiveau);
	Fond.graphics.clear();//Supprimer le fond blanc
	Fond.FlouFinal=0;
	Fond.Flou=Fond.FLOU_FINAL;
	addChild(Fond);

	//Repasser la boite de message au premier plan
	setChildIndex(Fond,1);

 	addEventListener(Event.ENTER_FRAME,FlouFinNiveau);
	addEventListener(Event.ENTER_FRAME,TesterFinNiveau);
	ChangeLevelInfo.htmlText="<u>Liste des niveaux</u>";
}

////////////////////////////////////////
//Partie grant les effets graphiques
////////////////////////////////////////

function FlouFinNiveau(e:Event):void
{//Flouter le niveau en arrire plan
	if(Fond.Flou!=Fond.FlouFinal)
	{
		if(Fond.Flou<Fond.FlouFinal)
			Fond.Flou+=2;
		else
			Fond.Flou-=2;
// 		var FiltreFlou:BitmapFilter = new BlurFilter(Fond.Flou,Fond.Flou)
// 		var ListeFiltres:Array = new Array();
// 		ListeFiltres.push(FiltreFlou);
// 		Fond.filters=ListeFiltres;
		if(Fond.FlouFinal==0)
		{
			Boite.alpha=Math.max(0,Fond.Flou/Fond.FLOU_FINAL);
			if(Fond.Flou==0)
				Boite.visible=false;
		}
		else
		{
			Boite.visible=true;
			Boite.alpha = Math.min(1,2*Fond.Flou/Fond.FlouFinal);
		}
	}
	else
	{
		if(Boite.alpha>.5)
			Boite.visible=true;
		else
			Boite.visible=false;
		removeEventListener(Event.ENTER_FRAME,FlouFinNiveau);
	}
}

function ChargementNiveauDirect(e:Event):void
{
	while(Boite.numChildren > 0)
	{
		Boite.removeChildAt(0);
	}
	Boite.addChild(ChangeLevelInfo);
	ChangeLevelInfo.htmlText="<u>Chargement en cours</u> (niv. <b>"+e.currentTarget.NumeroNiveau+"</b>)";
	if(e.currentTarget.Officiel)
	{
		NumeroNiveauActuel=e.currentTarget.NumeroNiveau;
		LancerNouveauNiveau(e.currentTarget.NumeroNiveau);
	}
	else
		LancerChargement();
}